module Pointless.Combinators.Uncurried where

import Pointless.Combinators
import Pointless.Isomorphisms
-- Point-free higher-order combinators

split :: (a -> b, a -> c) -> (a -> (b,c))
split = curry ((app >< app) . ((fst >< id) /\ (snd >< id)))

comp :: (b -> c, a -> b) -> (a -> c)
comp = curry (app . (id >< app) . assocr)

