{-# OPTIONS -fglasgow-exts #-}

module Pointless.Syntax.Types where

import Data.Generics hiding ((:*:))

type Name = Int

data Type = One
	  | Base Name
	  | Type :*: Type
	  | Type :-> Type
	    deriving (Eq, Typeable, Data)

instance Show Type
    where show One      = "()"
	  show (Base t)  = "a"++(show t)
	  show (t :*: u) = "("++(show t)++" , "++(show u)++")"
	  show (t :-> u) = "("++(show t)++" -> "++(show u)++")"
