---

x :: (HasValue i, HasValue j) 
  => ((x,y) -> CGI ()) 
  -> F2 (i x) (j y) VALID -> CGI ()
x valueCGI (F2 h1 h2) = valueCGI (value h1, value h2)
  
data Phantom x = Phantom
mapPhantom :: (x -> y) -> Phantom x -> Phantom y
mapPhantom f Phantom = Phantom

----

f0CGI :: () -> CGI ()
f0CGI () = standardQuery "F0" empty

fileCGI :: FileReference -> CGI ()
fileCGI file = standardQuery "File" empty

f2CGI :: (FileReference,FileReference) -> CGI ()
f2CGI (a,b) = standardQuery "F2" empty

listCGI :: [x] -> CGI ()
listCGI xs = standardQuery "List" empty

f0Form :: CGI ()
f0Form = standardQuery "Form" $ do
  h <- return F0
  submit h cgi (fieldVALUE "ok")
  where
    cgi = f0CGI . getValue

f0Form' = mkForm "Ok" () f0CGI ()

fileForm :: CGI ()
fileForm = standardQuery "Form" $ do
  h <- fileInputField empty
  submit h cgi (fieldVALUE "ok")
  where
    cgi = fileCGI . getValue

fileForm' = mkForm "Ok" "Browse" fileCGI undefined

f2Form :: CGI ()
f2Form = standardQuery "Form" $ do
  h1 <- fileInputField empty
  h2 <- fileInputField empty
  h <- return (F2 h1 h2)
  submit h cgi (fieldVALUE "ok")
  where
    cgi = f2CGI . getValue

f2Form' = mkForm "Ok" ("First","Second") f2CGI undefined

listForm = mkForm "Ok" "Choose on or more" listCGI [1,2,3]
 
----