module GLRActionsTable where


import List
import Language.ContextFree.Cfg 
import Language.ContextFree.LR_0
import Language.ContextFree.SLR
import Language.ContextFree.G_LR
import Language.ContextFree.G_SLR
import Language.ContextFree.G_LR_Inc_Semantics
import Language.ContextFree.G_LR_Semantics
import Language.ContextFree.MemoInc_G_LR

g = Cfg {terminals = [T 'i',T '+',T '*'], nonterminals = [NT 'E'], root = NT 'E', prods = [("add",[NT 'E',NT 'E',T '+',NT 'E']),("mul",[NT 'E',NT 'E',T '*',NT 'E']),("val",[NT 'E',T 'i'])]}
-- at' :: [[[Action Int [Symb Char Char]]]]
at' = [[[Shift 1],[Error],[Error],[Error]],[[Error],[Reduce [NT 'E',T 'i']],[Reduce [NT 'E',T 'i']],[Reduce [NT 'E',T 'i']]],[[Error],[Error],[Error],[Error]],[[Error],[Shift 4],[Shift 5],[Accept]],[[Shift 1],[Error],[Error],[Error]],[[Shift 1],[Error],[Error],[Error]],[[Error],[Error],[Error],[Error]],[[Error],[Shift 4,Reduce [NT 'E',NT 'E',T '+',NT 'E']],[Shift 5,Reduce [NT 'E',NT 'E',T '+',NT 'E']],[Reduce [NT 'E',NT 'E',T '+',NT 'E']]],[[Error],[Shift 4,Reduce [NT 'E',NT 'E',T '*',NT 'E']],[Shift 5,Reduce [NT 'E',NT 'E',T '*',NT 'E']],[Reduce [NT 'E',NT 'E',T '*',NT 'E']]]]

-- delta :: Int -> (Symb Char) -> Int

lookup_TT = delta



delta 0 (T 'i') = 1


delta 0 (T '+') = 2


delta 0 (T '*') = 2


delta 0 (Dollar) = 2


delta 0 (NT 'E') = 3


delta 1 (T 'i') = 2


delta 1 (T '+') = 2


delta 1 (T '*') = 2


delta 1 (Dollar) = 2


delta 1 (NT 'E') = 2


delta 2 (T 'i') = 2


delta 2 (T '+') = 2


delta 2 (T '*') = 2


delta 2 (Dollar) = 2


delta 2 (NT 'E') = 2


delta 3 (T 'i') = 2


delta 3 (T '+') = 4


delta 3 (T '*') = 5


delta 3 (Dollar) = 6


delta 3 (NT 'E') = 2


delta 4 (T 'i') = 1


delta 4 (T '+') = 2


delta 4 (T '*') = 2


delta 4 (Dollar) = 2


delta 4 (NT 'E') = 7


delta 5 (T 'i') = 1


delta 5 (T '+') = 2


delta 5 (T '*') = 2


delta 5 (Dollar) = 2


delta 5 (NT 'E') = 8


delta 6 (T 'i') = 2


delta 6 (T '+') = 2


delta 6 (T '*') = 2


delta 6 (Dollar) = 2


delta 6 (NT 'E') = 2


delta 7 (T 'i') = 2


delta 7 (T '+') = 4


delta 7 (T '*') = 5


delta 7 (Dollar) = 2


delta 7 (NT 'E') = 2


delta 8 (T 'i') = 2


delta 8 (T '+') = 4


delta 8 (T '*') = 5


delta 8 (Dollar) = 2


delta 8 (NT 'E') = 2



start_state = 0

t = [T 'i',T '+',T '*',Dollar]

lookup_AT :: Int -> Symb Char Char -> [Action Int [Symb Char Char]]
lookup_AT st sy = (at' !! st) !! col --  ????
  where (Just col) = sy `elemIndex` t

glr_parser inp = glr lookup_TT lookup_AT [start_state] inp
glr_parser_inc_xml inp = glr_inc_sem xml ([],g) lookup_TT lookup_AT [start_state] inp
glr_parser_inc_aterm inp = glr_inc_sem aterm ([],g) lookup_TT lookup_AT [start_state] inp
glr_parser_xml inp = glr_sem xml ([],g) lookup_TT lookup_AT [start_state] inp
glr_parser_aterm inp = glr_sem aterm ([],g) lookup_TT lookup_AT [start_state] inp
glr_parser_inc inp = glr_inc lookup_TT lookup_AT [start_state] inp


-- atblIndWSts = False

-- at = []
-- d st _ = st
