
module GLR_Gen where

import Language.ContextFree.Cfg
import Language.ContextFree.LR_0
import Language.ContextFree.G_SLR

import Language.ContextFree.Examples


glr_gen g =
  do  let eg          = expand_cfg g
      let gotoTable   = lr_0_tt  eg 
      let actionTable = e_slr_at eg
      
      let fw          = writeFile "GLRtables.hs"
      
      fw (show "gotoTable = ")
      fw (("module GLRtables where\n\n") ++
          ("import G_SLR\n\n")           ++
          ("voc = " ++ (show (terminals eg))) ++ "\n\n" ++
          ("gotoTable = " ++ (show gotoTable)) ++ "\n\n" ++
          ("actionTable = " ++ (show actionTable))
         )

