module LRActionsTable where


import List 
import Language.ContextFree.Cfg 
import Language.ContextFree.LR
import Language.ContextFree.LR_Semantics
import Language.ContextFree.LR_0
import Language.ContextFree.SLR

g' = Cfg {terminals = [T 'i',T '+',T '*'], nonterminals = [NT 'E'], root = NT 'E', prods = [("add",[NT 'E',NT 'E',T '+',NT 'E']),("mul",[NT 'E',NT 'E',T '*',NT 'E']),("val",[NT 'E',T 'i'])]}
-- at' :: [[Action [Symb Char]]]
at' = [[Shift 1,Error,Error,Error],[Error,Reduce [NT 'E',T 'i'],Reduce [NT 'E',T 'i'],Reduce [NT 'E',T 'i']],[Error,Error,Error,Error],[Error,Shift 4,Shift 5,Accept],[Shift 1,Error,Error,Error],[Shift 1,Error,Error,Error],[Error,Error,Error,Error],[Error,Shift 4,Shift 5,Reduce [NT 'E',NT 'E',T '+',NT 'E']],[Error,Shift 4,Shift 5,Reduce [NT 'E',NT 'E',T '*',NT 'E']]]

-- d' :: Int -> (Symb Char) -> Int

lookup_TT = delta



delta 0 (T 'i') = 1


delta 0 (T '+') = 2


delta 0 (T '*') = 2


delta 0 (Dollar) = 2


delta 0 (NT 'E') = 3


delta 1 (T 'i') = 2


delta 1 (T '+') = 2


delta 1 (T '*') = 2


delta 1 (Dollar) = 2


delta 1 (NT 'E') = 2


delta 2 (T 'i') = 2


delta 2 (T '+') = 2


delta 2 (T '*') = 2


delta 2 (Dollar) = 2


delta 2 (NT 'E') = 2


delta 3 (T 'i') = 2


delta 3 (T '+') = 4


delta 3 (T '*') = 5


delta 3 (Dollar) = 6


delta 3 (NT 'E') = 2


delta 4 (T 'i') = 1


delta 4 (T '+') = 2


delta 4 (T '*') = 2


delta 4 (Dollar) = 2


delta 4 (NT 'E') = 7


delta 5 (T 'i') = 1


delta 5 (T '+') = 2


delta 5 (T '*') = 2


delta 5 (Dollar) = 2


delta 5 (NT 'E') = 8


delta 6 (T 'i') = 2


delta 6 (T '+') = 2


delta 6 (T '*') = 2


delta 6 (Dollar) = 2


delta 6 (NT 'E') = 2


delta 7 (T 'i') = 2


delta 7 (T '+') = 4


delta 7 (T '*') = 5


delta 7 (Dollar) = 2


delta 7 (NT 'E') = 2


delta 8 (T 'i') = 2


delta 8 (T '+') = 4


delta 8 (T '*') = 5


delta 8 (Dollar) = 2


delta 8 (NT 'E') = 2


-- atblIndWSts = False

-- at = []
-- d st _ = st
start_state = 0

t = [T 'i',T '+',T '*',Dollar]

lookup_AT :: Int -> Symb Char Char -> Action Int [Symb Char Char]
lookup_AT st sy = (at' !! st) !! col --  ????
  where (Just col) = sy `elemIndex` t

lr_parser inp = lr lookup_TT lookup_AT [start_state] inp
lr_parser_xml inp = lr_sem xml ([],g') lookup_TT lookup_AT [start_state] inp
lr_parser_aterm inp = lr_sem aterm ([],g') lookup_TT lookup_AT [start_state] inp
